/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * GUI.java
 *
 * Created on May 12, 2010, 6:04:14 PM
 */

package gui;

import java.awt.event.ActionEvent;
import java.io.IOException;
import java.util.List;
import java.util.ResourceBundle;
import java.util.concurrent.ExecutionException;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.SwingWorker;

/**
 *
 * @author bar
 */

public class GUI extends javax.swing.JFrame {

    private ResourceBundle bundle = ResourceBundle.getBundle("gui");
    private Logger logger = Logger.getLogger(getClass().getName());
    private Icon runIcon = new ImageIcon("/usr/share/icons/hicolor/22x22/actions/speak.png");

    enum Action{PRIDAT,ZMENIT,VYBRAT};
    class OurWorker extends SwingWorker<Integer,Integer>{
        Integer value;
        Action action;

        public void setAction(Action action) {
            this.action = action;
        }

        public void setValue(Integer value) {
            this.value = value;
        }


        @Override
        protected Integer doInBackground() throws Exception {
            int sum = 0;
            for(int i=1;i<=1000;i++){
                sum += i;
                Thread.sleep(10);
                if( i%10 == 0 ) publish(i/10);
            }
            return sum;
        }

        public void done(){

            try {
                Handler fileHandler = new FileHandler("gui.log");
               // fileHandler.setFormatter(new SimpleFormatter());
                logger.addHandler(fileHandler);
                jTextArea1.append(get() + "");
                logger.log(Level.INFO,get()+"");
            } catch (IOException ex) {
                Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
            } catch (SecurityException ex) {
                Logger.getLogger(GUI.class.getName()).log(Level.SEVERE, null, ex);
            } catch (InterruptedException ex) {
                logger.log(Level.SEVERE, null, ex);
            } catch (ExecutionException ex) {
                logger.log(Level.SEVERE, null, ex);
            }

        }

        protected void process(List<Integer> data){
            jProgressBar1.setValue(data.get(data.size()-1));
        }

    }

    class RunAction extends AbstractAction{

        public RunAction(String desc){
            super(desc);
        }

        public RunAction(String desc,Icon icn){
            super(desc,icn);
        }


        public void actionPerformed(ActionEvent actionEvent) {
            
            OurWorker worker = new OurWorker();
            worker.execute();
            
        }

    }

    class ExitAction extends AbstractAction{
        public ExitAction(String desc){
            super(desc);
        }

        public void actionPerformed(ActionEvent arg0) {
            System.exit(0);
        }
    }
    /** Creates new form GUI */
    public GUI() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jProgressBar1 = new javax.swing.JProgressBar();
        jToolBar1 = new javax.swing.JToolBar();
        jButton1 = new javax.swing.JButton();
        jMenuBar1 = new javax.swing.JMenuBar();
        jMenu1 = new javax.swing.JMenu();
        jMenuItem1 = new javax.swing.JMenuItem();
        jMenuItem2 = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTextArea1.setColumns(20);
        jTextArea1.setRows(5);
        jScrollPane1.setViewportView(jTextArea1);

        jToolBar1.setRollover(true);

        jButton1.setAction(new RunAction(bundle.getString("run"),runIcon));
        jButton1.setFocusable(false);
        jButton1.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jButton1.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        jToolBar1.add(jButton1);

        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("gui"); // NOI18N
        jMenu1.setText(bundle.getString("file")); // NOI18N

        jMenuItem1.setAction(new RunAction(bundle.getString("run")));
        jMenu1.add(jMenuItem1);

        jMenuItem2.setAction(new ExitAction(bundle.getString("exit")));
        jMenu1.add(jMenuItem2);

        jMenuBar1.add(jMenu1);

        setJMenuBar(jMenuBar1);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jProgressBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 427, Short.MAX_VALUE)
            .addComponent(jScrollPane1, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, 427, Short.MAX_VALUE)
            .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 427, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addComponent(jToolBar1, javax.swing.GroupLayout.DEFAULT_SIZE, 51, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 230, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jProgressBar1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new GUI().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JMenu jMenu1;
    private javax.swing.JMenuBar jMenuBar1;
    private javax.swing.JMenuItem jMenuItem1;
    private javax.swing.JMenuItem jMenuItem2;
    private javax.swing.JProgressBar jProgressBar1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JToolBar jToolBar1;
    // End of variables declaration//GEN-END:variables

}
